{-# LANGUAGE AllowAmbiguousTypes #-}
{-# LANGUAGE OverloadedStrings #-}
module HUnit.Arithmetic where

import Protocol.Arithmetic
import HUnit.Utils

hunit :: TestTree
hunit = testGroup "Arithmetic"
 [ testGroup "inv"
	 [ testGroup "WeakParams"
		 [ testCase "groupGen" $
			inv (groupGen @WeakParams) @?=
				groupGen ^ E (groupOrder @WeakParams + neg one)
		 ]
	 , testGroup "BeleniosParams"
		 [ testCase "groupGen" $
			inv (groupGen @BeleniosParams) @?=
				groupGen ^ E (groupOrder @BeleniosParams + neg one)
		 ]
	 ]
 , testGroup "hash"
	 [ testGroup "WeakParams"
		 [ testCase "[groupGen]" $
			hash "start" [groupGen @WeakParams] @?= inE 80
		 , testCase "[groupGen, groupGen]" $
			hash "start" [groupGen @WeakParams, groupGen] @?= inE 117
		 ]
	 , testGroup "BeleniosParams"
		 [ testCase "[groupGen]" $
			hash "start" [groupGen @BeleniosParams] @?=
				inE 1115773133278002110129249165266
		 , testCase "[groupGen, groupGen]" $
			hash "start" [groupGen @BeleniosParams, groupGen] @?=
				inE 1237765159213600087872608890753
		 ]
	 ]
 ]
